'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (ast) {
  ast.BlockStatementNode.prototype.compile = function (figure) {
    var _this = this;

    var blockName = (0, _utils.getStringLiteralValue)(this.name);
    var template = blockName;
    var child = 'child' + figure.uniqid('child_name');

    var placeholder = undefined,
        parentNode = (0, _utils.lookUpOnlyOneChild)(this);
    if (parentNode) {
      placeholder = parentNode.nodeName;
    } else {
      placeholder = 'block' + figure.uniqid('placeholder');
      figure.declarations.push((0, _sourceNode.sourceNode)(null, 'var ' + placeholder + ' = document.createComment(\'block\');'));
    }

    figure.declarations.push((0, _sourceNode.sourceNode)(null, 'var ' + child + ' = {}; // Block "' + blockName + '".'));

    // Insert into parent on render
    figure.renderActions.push((0, _sourceNode.sourceNode)(this.loc, ['      monkberry.insert(view, ' + placeholder + ', ' + child + ', \'' + template + '\', {}, true);']));

    if (this.body.length > 0) {
      figure.subFigures.push(figure.createFigure(template, this.body));
      var variablesOfBody = (0, _variable.collectVariables)(this.body);

      variablesOfBody.forEach(function (variable) {
        return figure.onUpdater(variable).add((0, _sourceNode.sourceNode)(_this.loc, '      ' + child + '.ref && ' + child + '.ref.__update__.' + variable + '(__data__, ' + variable + ')'));
      });
    }

    return parentNode ? null : placeholder;
  };
};

var _sourceNode = require('./sourceNode');

var _variable = require('./expression/variable');

var _utils = require('../utils');