'use strict';

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (ast) {
  ast.ElementNode.prototype.compileCustom = function (figure) {
    var _this = this;

    var customNodeName = this.name;
    var templateName = customNodeName;
    var childName = 'child' + figure.uniqid('child_name');

    var placeholder = undefined;
    var parentNode = (0, _utils.lookUpOnlyOneChild)(this);
    if (parentNode) {
      placeholder = parentNode.nodeName;
    } else {
      placeholder = 'custom' + figure.uniqid('placeholder');
      figure.declare(['var ' + placeholder + ' = document.createComment(\'' + customNodeName + '\');']);
    }
    figure.declare(['var ' + childName + ' = {};']);

    var data = [];
    var variables = [];

    // Collect info about variables and attributes.
    var _iteratorNormalCompletion = true;
    var _didIteratorError = false;
    var _iteratorError = undefined;

    try {
      var _loop = function _loop() {
        var attr = _step.value;

        if (attr.type == 'SpreadAttribute') {

          figure.addUpdater(_this.loc, [attr.identifier.name], function () {
            return (0, _sourceNode.sourceNode)(_this.loc, ['      monkberry.insert(view, ' + placeholder + ', ' + childName + ', \'' + templateName + '\', ' + attr.identifier.name + ', true)']);
          });
        } else {
          var _attr$compileToExpres = attr.compileToExpression();

          var _attr$compileToExpres2 = _slicedToArray(_attr$compileToExpres, 1);

          var expr = _attr$compileToExpres2[0]; // TODO: Add support for default value in custom tag attributes attr={{ value || 'default' }}.

          variables = variables.concat((0, _variable.collectVariables)(expr));

          var property = (0, _sourceNode.sourceNode)(_this.loc, ['\'' + attr.name + '\': ' + expr.compile()]);
          data.push(property);
        }
      };

      for (var _iterator = this.attributes[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
        _loop();
      }
    } catch (err) {
      _didIteratorError = true;
      _iteratorError = err;
    } finally {
      try {
        if (!_iteratorNormalCompletion && _iterator.return) {
          _iterator.return();
        }
      } finally {
        if (_didIteratorError) {
          throw _iteratorError;
        }
      }
    }

    variables = (0, _utils.unique)(variables);
    data = '{' + data.join(', ') + '}';

    // Add complex/caching updater for custom attribute or insert on render if no variables in attributes.
    if (variables.length > 0) {

      figure.addUpdater(this.loc, variables, function () {
        return (0, _sourceNode.sourceNode)(_this.loc, ['      monkberry.insert(view, ' + placeholder + ', ' + childName + ', \'' + templateName + '\', ' + data + ', true)']);
      });
    } else {

      figure.renderActions.push((0, _sourceNode.sourceNode)(this.loc, ['      monkberry.insert(view, ' + placeholder + ', ' + childName + ', \'' + templateName + '\', ' + data + ', true);']));
    }

    if (this.body.length > 0) {
      figure.subFigures.push(figure.createFigure(templateName, this.body));
    }

    return parentNode ? null : placeholder;
  };
};

var _sourceNode = require('../sourceNode');

var _variable = require('../expression/variable');

var _utils = require('../../utils');