'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (ast) {
  ast.ElementNode.prototype.compileHtml = function (figure) {
    var _this = this;

    this.nodeName = this.name + figure.uniqid();

    figure.declarations.push((0, _sourceNode.sourceNode)(this.loc, ["var ", this.nodeName, " = document.createElement('", this.name, "');"]));

    var children = (0, _utils.map)(this.body, function (node) {
      node.parent = _this; // This is needed for backward lookup then optimizing "if" and "for".
      return node.compile(figure);
    });

    var _iteratorNormalCompletion = true;
    var _didIteratorError = false;
    var _iteratorError = undefined;

    try {
      for (var _iterator = children[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
        var child = _step.value;

        figure.construct.push((0, _sourceNode.sourceNode)(this.loc, [this.nodeName, ".appendChild(", child, ");"]));
      }
    } catch (err) {
      _didIteratorError = true;
      _iteratorError = err;
    } finally {
      try {
        if (!_iteratorNormalCompletion && _iterator.return) {
          _iterator.return();
        }
      } finally {
        if (_didIteratorError) {
          throw _iteratorError;
        }
      }
    }

    this.attributes.map(function (attr) {
      return attr.compile(figure, _this.nodeName);
    });

    return this.nodeName;
  };
};

var _sourceNode = require('../sourceNode');

var _utils = require('../../utils');