'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Root = undefined;

var _sourceNode = require('../compiler/sourceNode');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Root = exports.Root = function () {
  function Root() {
    _classCallCheck(this, Root);

    this.imports = {};
    this.functions = {};
  }

  _createClass(Root, [{
    key: 'compile',
    value: function compile() {
      var _this = this;

      var sn = (0, _sourceNode.sourceNode)(null, '');

      // Compile imports.
      Object.keys(this.imports).forEach(function (path) {
        var loc = _this.imports[path];
        sn.add((0, _sourceNode.sourceNode)(loc, 'monkberry.mount(require(' + path + '));\n'));
      });

      // Compile functions.
      if (Object.keys(this.functions).length > 0) {
        var defn = [];
        Object.keys(this.functions).forEach(function (key) {
          defn.push((0, _sourceNode.sourceNode)(null, key + ' = ' + _this.functions[key]));
        });
        sn.add((0, _sourceNode.sourceNode)(null, 'var ').add((0, _sourceNode.join)(defn, ',\n')).add(';\n'));
      }

      return sn;
    }
  }, {
    key: 'addImport',
    value: function addImport(loc, path) {
      if (!(path in this.imports)) {
        this.imports[path] = loc;
      }
    }
  }, {
    key: 'addFunction',
    value: function addFunction(name, source) {
      if (!(name in this.functions)) {
        this.functions[name] = source;
      }
    }
  }]);

  return Root;
}();