'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.sourceNode = sourceNode;
exports.join = join;

var _sourceMap = require('source-map');

function sourceNode(loc, chunk) {
  // Check call arity.
  if (chunk == undefined) {
    chunk = loc;
    loc = null;
  }

  if (!loc) {
    return new _sourceMap.SourceNode(null, null, null, chunk);
  } else {
    return new _sourceMap.SourceNode(loc.start.line, loc.start.column, loc.source, chunk);
  }
}

function join(parts) {
  var separator = arguments.length <= 1 || arguments[1] === undefined ? '' : arguments[1];

  return sourceNode(null, parts).join(separator);
}